DirectMethodHandleDesc.Kind (Java SE 26 & JDK 26)
Description: declaration: module: java.base, package: java.lang.constant, interface: DirectMethodHandleDesc, enum: Kind
Keywords: java.lang.constant.DirectMethodHandleDesc.Kind class

# Enum Class DirectMethodHandleDesc.Kind

java.lang.Object
java.lang.Enum<DirectMethodHandleDesc.Kind>
java.lang.constant.DirectMethodHandleDesc.Kind

All Implemented Interfaces:
  `Serializable, Comparable<DirectMethodHandleDesc.Kind>, Constable`

Enclosing interface:
  `DirectMethodHandleDesc`

public static enum DirectMethodHandleDesc.Kind extends Enum<DirectMethodHandleDesc.Kind>
Kinds of method handles that can be described with DirectMethodHandleDesc.

Since:
  12

- ## Nested Class Summary

  ### Nested classes/interfaces declared in class Enum

  `Enum.EnumDesc<E>`
  Modifier and Type
  Class
  Description
  `static final class`
  `Enum.EnumDesc<E extends Enum<E>>`
  A nominal descriptor for an `enum` constant.

- ## Enum Constant Summary

  Enum Constants
  Enum Constant
  Description
  `CONSTRUCTOR`
  A method handle for a constructor
  `GETTER`
  A method handle for a read accessor for an instance field
  `INTERFACE_SPECIAL`
  A method handle for an interface method invoked as with `invokespecial`
  `INTERFACE_STATIC`
  A method handle for a method invoked as with `invokestatic`
  `INTERFACE_VIRTUAL`
  A method handle for a method invoked as with `invokeinterface`
  `SETTER`
  A method handle for a write accessor for an instance field
  `SPECIAL`
  A method handle for a method invoked as with `invokespecial`
  `STATIC`
  A method handle for a method invoked as with `invokestatic`
  `STATIC_GETTER`
  A method handle for a read accessor for a static field
  `STATIC_SETTER`
  A method handle for a write accessor for a static field
  `VIRTUAL`
  A method handle for a method invoked as with `invokevirtual`

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `final boolean`
  `isInterface`
  Is this an interface
  `final int`
  `refKind`
  The corresponding `refKind` value for this kind of method handle, as defined by `MethodHandleInfo`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static DirectMethodHandleDesc.Kind`
  `valueOf(int refKind)`
  Returns the enumeration member with the given `refKind` field.
  `static DirectMethodHandleDesc.Kind`
  `valueOf(int refKind, boolean isInterface)`
  Returns the enumeration member with the given the `refKind` and `isInterface` arguments.
  `static DirectMethodHandleDesc.Kind`
  `valueOf(String name)`
  Returns the enum constant of this class with the specified name.
  `static DirectMethodHandleDesc.Kind[]`
  `values()`
  Returns an array containing the constants of this enum class, in the order they are declared.

  ### Methods declared in class Enum

  `clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`
  Modifier and Type
  Method
  Description
  `protected final Object`
  `clone()`
  Throws CloneNotSupportedException.
  `final int`
  `compareTo(DirectMethodHandleDesc.Kind o)`
  Compares this enum with the specified object for order.
  `final Optional<Enum.EnumDesc<DirectMethodHandleDesc.Kind>>`
  `describeConstable()`
  Returns an enum descriptor `EnumDesc` for this instance, if one can be constructed, or an empty `Optional` if one cannot be.
  `final boolean`
  `equals(Object other)`
  Returns true if the specified object is equal to this enum constant.
  `protected final void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization has been deprecated for removal.
  `final Class<DirectMethodHandleDesc.Kind>`
  `getDeclaringClass()`
  Returns the Class object corresponding to this enum constant's enum type.
  `final int`
  `hashCode()`
  Returns a hash code for this enum constant.
  `final String`
  `name()`
  Returns the name of this enum constant, exactly as declared in its enum declaration.
  `final int`
  `ordinal()`
  Returns the ordinal of this enumeration constant (its position in its enum declaration, where the initial constant is assigned an ordinal of zero).
  `String`
  `toString()`
  Returns the name of this enum constant, as contained in the declaration.
  `static <T extends Enum<T>>
  T`
  `valueOf(Class<T> enumClass, String name)`
  Returns the enum constant of the specified enum class with the specified name.

  ### Methods declared in class Object

  `getClass, notify, notifyAll, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

- ## Enum Constant Details

  - ### STATIC

    public static final DirectMethodHandleDesc.Kind STATIC
    A method handle for a method invoked as with `invokestatic`

  - ### INTERFACE_STATIC

    public static final DirectMethodHandleDesc.Kind INTERFACE_STATIC
    A method handle for a method invoked as with `invokestatic`

  - ### VIRTUAL

    public static final DirectMethodHandleDesc.Kind VIRTUAL
    A method handle for a method invoked as with `invokevirtual`

  - ### INTERFACE_VIRTUAL

    public static final DirectMethodHandleDesc.Kind INTERFACE_VIRTUAL
    A method handle for a method invoked as with `invokeinterface`

  - ### SPECIAL

    public static final DirectMethodHandleDesc.Kind SPECIAL
    A method handle for a method invoked as with `invokespecial`

  - ### INTERFACE_SPECIAL

    public static final DirectMethodHandleDesc.Kind INTERFACE_SPECIAL
    A method handle for an interface method invoked as with `invokespecial`

  - ### CONSTRUCTOR

    public static final DirectMethodHandleDesc.Kind CONSTRUCTOR
    A method handle for a constructor

  - ### GETTER

    public static final DirectMethodHandleDesc.Kind GETTER
    A method handle for a read accessor for an instance field

  - ### SETTER

    public static final DirectMethodHandleDesc.Kind SETTER
    A method handle for a write accessor for an instance field

  - ### STATIC_GETTER

    public static final DirectMethodHandleDesc.Kind STATIC_GETTER
    A method handle for a read accessor for a static field

  - ### STATIC_SETTER

    public static final DirectMethodHandleDesc.Kind STATIC_SETTER
    A method handle for a write accessor for a static field

- ## Field Details

  - ### refKind

    public final int refKind
    The corresponding `refKind` value for this kind of method handle, as defined by `MethodHandleInfo`

  - ### isInterface

    public final boolean isInterface
    Is this an interface

- ## Method Details

  - ### values

    public static DirectMethodHandleDesc.Kind[] values()
    Returns an array containing the constants of this enum class, in the order they are declared.
    Returns:
      an array containing the constants of this enum class, in the order they are declared

  - ### valueOf

    public static DirectMethodHandleDesc.Kind valueOf(String name)
    Returns the enum constant of this class with the specified name. The string must match exactly an identifier used to declare an enum constant in this class. (Extraneous whitespace characters are not permitted.)
    Parameters:
      `name` - the name of the enum constant to be returned.
    Returns:
      the enum constant with the specified name
    Throws:
      `IllegalArgumentException` - if this enum class has no constant with the specified name
      `NullPointerException` - if the argument is null

  - ### valueOf

    public static DirectMethodHandleDesc.Kind valueOf(int refKind)
    Returns the enumeration member with the given `refKind` field. Behaves as if `valueOf(refKind, false)`. As a special case, if `refKind` is `REF_invokeInterface` (9) then the `isInterface` field will be true.
    Parameters:
      `refKind` - refKind of desired member
    Returns:
      the matching enumeration member
    Throws:
      `IllegalArgumentException` - if there is no such member

  - ### valueOf

    public static DirectMethodHandleDesc.Kind valueOf(int refKind, boolean isInterface)
    Returns the enumeration member with the given the `refKind` and `isInterface` arguments. For most values of `refKind` there is an exact match regardless of the value of `isInterface`. These are:
    - `REF_invokeVirtual` which matches to `VIRTUAL`
    - `REF_invokeInterface` which matches to `INTERFACE_VIRTUAL`
    - `REF_newInvokeSpecial` which matches to `CONSTRUCTOR`
    - `REF_getField` which matches to `GETTER`
    - `REF_putField` which matches to `SETTER`
    - `REF_getStatic` which matches to `STATIC_GETTER`
    - `REF_putStatic` which matches to `STATIC_SETTER`
    As for the rest, the returned kind will depend on the value (false or true accordingly) of `isInterface`:
    - `REF_invokeStatic` which matches to `STATIC` or `INTERFACE_STATIC`
    - `REF_invokeSpecial` which matches to `SPECIAL` or `INTERFACE_SPECIAL`
    Parameters:
      `refKind` - refKind of desired member
      `isInterface` - whether desired member is for interface methods
    Returns:
      the matching enumeration member
    Throws:
      `IllegalArgumentException` - if there is no such member